import getKiloName from './getLongKiloName'

it('should exist', () => {
  expect(getKiloName).toBeDefined()
})

it('should be a callable', () => {
  expect(typeof getKiloName).toBe('function')
})

it('should accept 1 argument', () => {
  expect(getKiloName).toHaveLength(1)
})

test.each`
  thousandPower | name
  ${0}          | ${''}
  ${1}          | ${'thousand'}
  ${2}          | ${'million'}
  ${3}          | ${'thousand million'}
  ${4}          | ${'billion'}
  ${5}          | ${'thousand billion'}
  ${6}          | ${'trillion'}
  ${7}          | ${'thousand trillion'}
  ${8}          | ${'quadrillion'}
  ${9}          | ${'thousand quadrillion'}
  ${10}         | ${'quintillion'}
  ${11}         | ${'thousand quintillion'}
  ${12}         | ${'sextillion'}
  ${13}         | ${'thousand sextillion'}
  ${14}         | ${'septillion'}
  ${15}         | ${'thousand septillion'}
  ${16}         | ${'octillion'}
  ${17}         | ${'thousand octillion'}
  ${18}         | ${'nonillion'}
  ${19}         | ${'thousand nonillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${20}         | ${'decillion'}
  ${40}         | ${'vigintillion'}
  ${60}         | ${'trigintillion'}
  ${80}         | ${'quadragintillion'}
  ${100}        | ${'quinquagintillion'}
  ${120}        | ${'sexagintillion'}
  ${140}        | ${'septuagintillion'}
  ${160}        | ${'octogintillion'}
  ${180}        | ${'nonagintillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${200}        | ${'centillion'}
  ${400}        | ${'duocentillion'}
  ${600}        | ${'trecentillion'}
  ${800}        | ${'quadringentillion'}
  ${1000}       | ${'quingentillion'}
  ${1200}       | ${'sescentillion'}
  ${1400}       | ${'septingentillion'}
  ${1600}       | ${'octingentillion'}
  ${1800}       | ${'nongentillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${2000}       | ${'milliatillion'}
  ${4000}       | ${'duomilliatillion'}
  ${6000}       | ${'tremilliatillion'}
  ${8000}       | ${'quattuormilliatillion'}
  ${10000}      | ${'quinmilliatillion'}
  ${12000}      | ${'sexmilliatillion'}
  ${14000}      | ${'septenmilliatillion'}
  ${16000}      | ${'octomilliatillion'}
  ${18000}      | ${'novemmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${20000}      | ${'decmilliatillion'}
  ${40000}      | ${'viginmilliatillion'}
  ${60000}      | ${'triginmilliatillion'}
  ${80000}      | ${'quadraginmilliatillion'}
  ${100000}     | ${'quinquaginmilliatillion'}
  ${120000}     | ${'sexaginmilliatillion'}
  ${140000}     | ${'septuaginmilliatillion'}
  ${160000}     | ${'octoginmilliatillion'}
  ${180000}     | ${'nonaginmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${200000}     | ${'cenmilliatillion'}
  ${400000}     | ${'duocenmilliatillion'}
  ${600000}     | ${'trecenmilliatillion'}
  ${800000}     | ${'quadringenmilliatillion'}
  ${1000000}    | ${'quingenmilliatillion'}
  ${1200000}    | ${'sescenmilliatillion'}
  ${1400000}    | ${'septingenmilliatillion'}
  ${1600000}    | ${'octingenmilliatillion'}
  ${1800000}    | ${'nongenmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${2000000}    | ${'milliamilliatillion'}
  ${4000000}    | ${'duomilliamilliatillion'}
  ${6000000}    | ${'tremilliamilliatillion'}
  ${8000000}    | ${'quattuormilliamilliatillion'}
  ${10000000}   | ${'quinmilliamilliatillion'}
  ${12000000}   | ${'sexmilliamilliatillion'}
  ${14000000}   | ${'septenmilliamilliatillion'}
  ${16000000}   | ${'octomilliamilliatillion'}
  ${18000000}   | ${'novemmilliamilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})
