import { GetKiloName, } from '../../common/NumberSystem'
import NAMES from './names.json'
import getKiloCombiningPrefix from './base/kilo/combiningPrefix'

const getLongKiloName: GetKiloName = thousandPower => {
  if (thousandPower === 0) {
    return ''
  }
  if (thousandPower === 1) {
    return NAMES.thousand
  }
  const kilo = thousandPower
  const kiloHundreds = Math.floor(kilo / 2 / 100)
  const kiloTens = Math.floor(kilo / 2 / 10 % 10)
  const kiloOnes = Math.floor(kilo / 2 % 10)
  const baseKiloName = getKiloCombiningPrefix(
    kiloHundreds,
    kiloTens,
    kiloOnes
  ) + NAMES.kiloEvenSuffix

  return (
    thousandPower % 2 === 0
      ? baseKiloName
      : NAMES.thousand + ' ' + baseKiloName
  )
}

export default getLongKiloName
