import getKiloName from './getShortKiloName'

it('should exist', () => {
  expect(getKiloName).toBeDefined()
})

it('should be a callable', () => {
  expect(typeof getKiloName).toBe('function')
})

it('should accept 1 argument', () => {
  expect(getKiloName).toHaveLength(1)
})

test.each`
  thousandPower | name
  ${0}          | ${''}
  ${1}          | ${'thousand'}
  ${2}          | ${'million'}
  ${3}          | ${'billion'}
  ${4}          | ${'trillion'}
  ${5}          | ${'quadrillion'}
  ${6}          | ${'quintillion'}
  ${7}          | ${'sextillion'}
  ${8}          | ${'septillion'}
  ${9}          | ${'octillion'}
  ${10}         | ${'nonillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${11}         | ${'decillion'}
  ${21}         | ${'vigintillion'}
  ${31}         | ${'trigintillion'}
  ${41}         | ${'quadragintillion'}
  ${51}         | ${'quinquagintillion'}
  ${61}         | ${'sexagintillion'}
  ${71}         | ${'septuagintillion'}
  ${81}         | ${'octogintillion'}
  ${91}         | ${'nonagintillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${101}        | ${'centillion'}
  ${201}        | ${'duocentillion'}
  ${301}        | ${'trecentillion'}
  ${401}        | ${'quadringentillion'}
  ${501}        | ${'quingentillion'}
  ${601}        | ${'sescentillion'}
  ${701}        | ${'septingentillion'}
  ${801}        | ${'octingentillion'}
  ${901}        | ${'nongentillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${1001}       | ${'milliatillion'}
  ${2001}       | ${'duomilliatillion'}
  ${3001}       | ${'tremilliatillion'}
  ${4001}       | ${'quattuormilliatillion'}
  ${5001}       | ${'quinmilliatillion'}
  ${6001}       | ${'sexmilliatillion'}
  ${7001}       | ${'septenmilliatillion'}
  ${8001}       | ${'octomilliatillion'}
  ${9001}       | ${'novemmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${10001}      | ${'decmilliatillion'}
  ${20001}      | ${'viginmilliatillion'}
  ${30001}      | ${'triginmilliatillion'}
  ${40001}      | ${'quadraginmilliatillion'}
  ${50001}      | ${'quinquaginmilliatillion'}
  ${60001}      | ${'sexaginmilliatillion'}
  ${70001}      | ${'septuaginmilliatillion'}
  ${80001}      | ${'octoginmilliatillion'}
  ${90001}      | ${'nonaginmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${100001}     | ${'cenmilliatillion'}
  ${200001}     | ${'duocenmilliatillion'}
  ${300001}     | ${'trecenmilliatillion'}
  ${400001}     | ${'quadringenmilliatillion'}
  ${500001}     | ${'quingenmilliatillion'}
  ${600001}     | ${'sescenmilliatillion'}
  ${700001}     | ${'septingenmilliatillion'}
  ${800001}     | ${'octingenmilliatillion'}
  ${900001}     | ${'nongenmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${1000001}    | ${'milliamilliatillion'}
  ${2000001}    | ${'duomilliamilliatillion'}
  ${3000001}    | ${'tremilliamilliatillion'}
  ${4000001}    | ${'quattuormilliamilliatillion'}
  ${5000001}    | ${'quinmilliamilliatillion'}
  ${6000001}    | ${'sexmilliamilliatillion'}
  ${7000001}    | ${'septenmilliamilliatillion'}
  ${8000001}    | ${'octomilliamilliatillion'}
  ${9000001}    | ${'novemmilliamilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})
