import { GetKiloName, } from '../../common/NumberSystem'
import NAMES from './names.json'
import getKiloCombiningPrefix from './base/kilo/combiningPrefix'

const getKiloName: GetKiloName = thousandPower => {
  if (thousandPower === 0) {
    return ''
  }
  if (thousandPower === 1) {
    return NAMES.thousand
  }
  const kilo = thousandPower - 1
  const kiloHundreds = Math.floor(kilo / 100)
  const kiloTens = Math.floor(kilo / 10 % 10)
  const kiloOnes = Math.floor(kilo % 10)

  return getKiloCombiningPrefix(
    kiloHundreds,
    kiloTens,
    kiloOnes
  ) + NAMES.kiloEvenSuffix
}

export default getKiloName
